#include <stdio.h>

void main(void)
{
  int i, nfds = 4, pollfds[4]={5,3,0,-1};
  struct
  {
    int type;
    int io_port;
  } d[nfds];
  for (i = 0; i < nfds; ++i)
    if (pollfds[i] >= 0)
      {
	int type = 2;
	d[i].type = pollfds[i];
	fprintf(stdout,"d[%d]=%d\n",i,d[i].type);
      }
    else
      {
	d[i].type = 0;
	fprintf(stdout,"d[%d]=%d\n",i,d[i].type);
      }

  for (i = 0; i < nfds; ++i)
    {
      if (pollfds[i] != 0)
	{
	  d[i].io_port = pollfds[i];
	  const int fd = (int) d[i].io_port;
	  
	  if (fd < 10)
	    {
	      d[i].type = pollfds[i];
	      fprintf(stdout,"d[%d]=%d\n",i,d[i].type);
	      
	      if (d[i].type != 0){
		fprintf(stdout,"d[%d]=%d\n",i,d[i].type);
		continue; /* Next i value */
	      }
	    }
	  
	  /* If one descriptor is bogus, we fail completely.  */
	  /* FIXME: Enter here too */
	  while (i-- > 0)
	    if (d[i].type != 0)
	      {
		fprintf(stdout,"d[%d]=%d\n",i,d[i].type);
	      }
           break;
	}
    } /* end for */
}
/*
Getting a list of signals: kill -l !!!
Running this program through gdb in Linux + Hurd:
Program exited with code 04: -g, -g -O0
Program exited with code 07: -g -O, -g -O2

Linux: /usr/include/asm/signal.h
#define SIGILL           4
#define SIGBUS           7

Hurd: /usr/include/bits/signum.h:
*/
//#define SIGILL          4       /* Illegal instruction (ANSI).  */
//#define SIGEMT          7       /* EMT trap (4.2 BSD). Emulation trap (Solaris)

/*
At http://www.linuxprogrammingblog.com/all-about-linux-signals?page=4:
Handling sigbus

The SIGBUS signal is sent to the process when you access mapped memory
(with mmap(2)) that doesn't correspond to a file. A common example is
that the file you've mapped was later truncated (possible by another
program) and you read past it's current end. Accessing files this way
doesn't require any system function that could return an error, you
just read from memory like if it was on the heap or stack. This is a
really bad situation when you don't want your program to terminate
after a file read error. Unfortunately handling SIGBUS isn't simple or
clean, but it's possible.
*/

