#define MAX_AF 4
/* ntpdate use MAX_AF=2 */

#undef HAVE_POLL_H
#define HAVE_POLL_H 1

#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <errno.h>

// Included by <ctype.h> or <bits/types.h> #include <bits/types.h>
#include <time.h> /* timespec definition */
#include <sys/time.h> /* timeval definition */
// Included by <time.h> if _TIME_H is defined #include <bits/time.h> /* timeval definition */
#include <bits/types.h>

#ifdef HAVE_POLL_H
# include <poll.h>
#else
/* According to POSIX.1-2001 */
# include <sys/select.h>
#endif

/* Struct pollfd defined here */
//struct pollfd {
//  int   fd;         /* file descriptor */
//  short events;     /* requested events */
//  short revents;    /* returned events */
//};

// From bits/poll.h
 /* Event types that can be polled for.  These bits may be set in `events'
   to indicate the interesting event types; they will appear in `revents'
   to indicate the status of the file descriptor.  */
//#define POLLIN          01              /* There is data to read.  */
//#define POLLPRI         02              /* There is urgent data to read.  */
//#define POLLOUT         04              /* Writing now will not block.  */
/* Event types always implicitly polled for.  These bits need not be set in
   `events', but they will appear in `revents' to indicate the status of
   the file descriptor.  */
//#define POLLERR         010             /* Error condition.  */
//#define POLLHUP         020             /* Hung up.  */
//#define POLLNVAL        040             /* Invalid polling request.  */
//On  error,  -1  is returned, and errno is set appropriately.


/* Struct fdset defined here */
/*
typedef struct
__fd_mask __fds_bits[__FD_SETSIZE / __NFDBITS];
# define __FDS_BITS(set) ((set)->__fds_bits)
} fd_set;
gcc -E: 
typedef long int __fd_mask;
__fd_mask fds_bits[256 / (8 * (int) sizeof (__fd_mask))
*/

int main(void)
{
  int i, j, nfound;
  int nbsock = 1, fd[MAX_AF];


/* 0=stdin, 1=stdout, 2=stderr */

struct timeval timeout = {5,0};

#ifdef HAVE_POLL_H
  struct pollfd fdmask[MAX_AF];
  fd[0]=4, fd[1]=5, fd[2]=0; fd[3]=1;
  for(i = 0; i < MAX_AF; ++i) {
    fdmask[i].fd = fd[i];
    fdmask[i].events = POLLIN; /* bits/poll.h: POLLIN=1, POLLOUT=4, POLLPRI=2 */
    fdmask[i].revents = 0;
  }
  //  fdmask[1].events = POLLOUT;
  //  fdmask[1].events = POLLPRI;

  struct pollfd* rdfdes;
  rdfdes = fdmask;
  nbsock = MAX_AF;
  for (j=0; j < MAX_AF; ++j)
    fprintf(stderr, "rdfdes[%d].{fd,events}={%d,%d}\n", j, rdfdes[j].fd, rdfdes[j].events);
  nfound = poll(rdfdes, (unsigned int)nbsock, timeout.tv_sec * 1000);
  fprintf(stderr, "nfound=%d\n", nfound);
  for (j=0; j < nbsock; ++j) {
    fprintf(stderr, "revents[%d]=%d\n", j, rdfdes[j].revents);
    if (nfound == -1) {
      perror("Poll error");
      fprintf(stderr, "error=%s, revents[%d]=%d\n", strerror(errno), j, rdfdes[j].revents);
    }
  }

#else

  fd_set fdmask;
  /*
 ../include/ntp_machine.h: typedef int SOCKET;
  SOCKET maxfd;
  */
  int maxfd=1;
  //  for(i = 0; i < MAX_AF; ++i) {
  fd[0]=0; fd[1]=1; fd[2]=2;
  FD_ZERO(&fdmask);
  for(i = 0; i < 1; ++i) {
    FD_SET(fd[i], &fdmask); /* sys/select.h: FD_SET, bits/select.h: __FD_SET */      if (maxfd < fd[i]+1) {
      maxfd = fd[i]+1;
    }
  }
  /*
    maxfd  is the highest-numbered file descriptor in any of the three sets,
    plus 1.
  */

  fd_set rdfdes;
  rdfdes = fdmask;
  nfound = select(maxfd, &rdfdes, (fd_set *)0, (fd_set *)0, &timeout);
  fprintf(stderr, "nfound=%d\n", nfound);
  if (nfound == -1)
    perror("select()");
  else if (nfound)
    printf("Data is available now.\n");
  /* FD_ISSET(0, &rfds) will be true. */
  else
    printf("No data within five seconds.\n");

  /* FIXME
  for (j=0; j < maxfd; ++j) {
    fprintf(stderr, "revents[%d]=%d\n", j, rdfdes[j].revents);
    if (nfound == -1) {
      perror("Poll error");
      fprintf(stderr, "error=%s, revents[%d]=%d\n", strerror(errno), j, rdfdes[j].revents);
    }
  }
run ./a.out -
fgdfg
nfound=1
Data is available now

Timeout:
nfound=0
No data within five seconds.

  */
#endif
  //exit(EXIT_SUCCESS); /* needs stdlib.h? */

return 0;
}
